package cloudesl

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// BindApStoreService invokes the cloudesl.BindApStoreService API synchronously
func (client *Client) BindApStoreService(request *BindApStoreServiceRequest) (response *BindApStoreServiceResponse, err error) {
	response = CreateBindApStoreServiceResponse()
	err = client.DoAction(request, response)
	return
}

// BindApStoreServiceWithChan invokes the cloudesl.BindApStoreService API asynchronously
func (client *Client) BindApStoreServiceWithChan(request *BindApStoreServiceRequest) (<-chan *BindApStoreServiceResponse, <-chan error) {
	responseChan := make(chan *BindApStoreServiceResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.BindApStoreService(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// BindApStoreServiceWithCallback invokes the cloudesl.BindApStoreService API asynchronously
func (client *Client) BindApStoreServiceWithCallback(request *BindApStoreServiceRequest, callback func(response *BindApStoreServiceResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *BindApStoreServiceResponse
		var err error
		defer close(result)
		response, err = client.BindApStoreService(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// BindApStoreServiceRequest is the request struct for api BindApStoreService
type BindApStoreServiceRequest struct {
	*requests.RpcRequest
	ApMac   string `position:"Query" name:"ApMac"`
	StoreId string `position:"Query" name:"StoreId"`
}

// BindApStoreServiceResponse is the response struct for api BindApStoreService
type BindApStoreServiceResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Success   bool   `json:"Success" xml:"Success"`
	Message   string `json:"Message" xml:"Message"`
	ErrorCode string `json:"ErrorCode" xml:"ErrorCode"`
}

// CreateBindApStoreServiceRequest creates a request to invoke BindApStoreService API
func CreateBindApStoreServiceRequest() (request *BindApStoreServiceRequest) {
	request = &BindApStoreServiceRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("cloudesl", "2018-08-01", "BindApStoreService", "cloudesl", "openAPI")
	request.Method = requests.POST
	return
}

// CreateBindApStoreServiceResponse creates a response to parse from BindApStoreService response
func CreateBindApStoreServiceResponse() (response *BindApStoreServiceResponse) {
	response = &BindApStoreServiceResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
