package cloudesl

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DeleteApService invokes the cloudesl.DeleteApService API synchronously
func (client *Client) DeleteApService(request *DeleteApServiceRequest) (response *DeleteApServiceResponse, err error) {
	response = CreateDeleteApServiceResponse()
	err = client.DoAction(request, response)
	return
}

// DeleteApServiceWithChan invokes the cloudesl.DeleteApService API asynchronously
func (client *Client) DeleteApServiceWithChan(request *DeleteApServiceRequest) (<-chan *DeleteApServiceResponse, <-chan error) {
	responseChan := make(chan *DeleteApServiceResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DeleteApService(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DeleteApServiceWithCallback invokes the cloudesl.DeleteApService API asynchronously
func (client *Client) DeleteApServiceWithCallback(request *DeleteApServiceRequest, callback func(response *DeleteApServiceResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DeleteApServiceResponse
		var err error
		defer close(result)
		response, err = client.DeleteApService(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DeleteApServiceRequest is the request struct for api DeleteApService
type DeleteApServiceRequest struct {
	*requests.RpcRequest
	ApMac   string `position:"Query" name:"ApMac"`
	StoreId string `position:"Query" name:"StoreId"`
}

// DeleteApServiceResponse is the response struct for api DeleteApService
type DeleteApServiceResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Success   bool   `json:"Success" xml:"Success"`
	Message   string `json:"Message" xml:"Message"`
	ErrorCode string `json:"ErrorCode" xml:"ErrorCode"`
}

// CreateDeleteApServiceRequest creates a request to invoke DeleteApService API
func CreateDeleteApServiceRequest() (request *DeleteApServiceRequest) {
	request = &DeleteApServiceRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("cloudesl", "2018-08-01", "DeleteApService", "cloudesl", "openAPI")
	request.Method = requests.POST
	return
}

// CreateDeleteApServiceResponse creates a response to parse from DeleteApService response
func CreateDeleteApServiceResponse() (response *DeleteApServiceResponse) {
	response = &DeleteApServiceResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
