package drds

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// CreateCustomDataExportPreCheckTask invokes the drds.CreateCustomDataExportPreCheckTask API synchronously
func (client *Client) CreateCustomDataExportPreCheckTask(request *CreateCustomDataExportPreCheckTaskRequest) (response *CreateCustomDataExportPreCheckTaskResponse, err error) {
	response = CreateCreateCustomDataExportPreCheckTaskResponse()
	err = client.DoAction(request, response)
	return
}

// CreateCustomDataExportPreCheckTaskWithChan invokes the drds.CreateCustomDataExportPreCheckTask API asynchronously
func (client *Client) CreateCustomDataExportPreCheckTaskWithChan(request *CreateCustomDataExportPreCheckTaskRequest) (<-chan *CreateCustomDataExportPreCheckTaskResponse, <-chan error) {
	responseChan := make(chan *CreateCustomDataExportPreCheckTaskResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.CreateCustomDataExportPreCheckTask(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// CreateCustomDataExportPreCheckTaskWithCallback invokes the drds.CreateCustomDataExportPreCheckTask API asynchronously
func (client *Client) CreateCustomDataExportPreCheckTaskWithCallback(request *CreateCustomDataExportPreCheckTaskRequest, callback func(response *CreateCustomDataExportPreCheckTaskResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *CreateCustomDataExportPreCheckTaskResponse
		var err error
		defer close(result)
		response, err = client.CreateCustomDataExportPreCheckTask(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// CreateCustomDataExportPreCheckTaskRequest is the request struct for api CreateCustomDataExportPreCheckTask
type CreateCustomDataExportPreCheckTaskRequest struct {
	*requests.RpcRequest
	ExportParam string `position:"Query" name:"ExportParam"`
}

// CreateCustomDataExportPreCheckTaskResponse is the response struct for api CreateCustomDataExportPreCheckTask
type CreateCustomDataExportPreCheckTaskResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Success   bool   `json:"Success" xml:"Success"`
	TaskId    int64  `json:"TaskId" xml:"TaskId"`
}

// CreateCreateCustomDataExportPreCheckTaskRequest creates a request to invoke CreateCustomDataExportPreCheckTask API
func CreateCreateCustomDataExportPreCheckTaskRequest() (request *CreateCustomDataExportPreCheckTaskRequest) {
	request = &CreateCustomDataExportPreCheckTaskRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Drds", "2019-01-23", "CreateCustomDataExportPreCheckTask", "Drds", "openAPI")
	request.Method = requests.POST
	return
}

// CreateCreateCustomDataExportPreCheckTaskResponse creates a response to parse from CreateCustomDataExportPreCheckTask response
func CreateCreateCustomDataExportPreCheckTaskResponse() (response *CreateCustomDataExportPreCheckTaskResponse) {
	response = &CreateCustomDataExportPreCheckTaskResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
