package drds

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// CreateCustomDataExportTask invokes the drds.CreateCustomDataExportTask API synchronously
func (client *Client) CreateCustomDataExportTask(request *CreateCustomDataExportTaskRequest) (response *CreateCustomDataExportTaskResponse, err error) {
	response = CreateCreateCustomDataExportTaskResponse()
	err = client.DoAction(request, response)
	return
}

// CreateCustomDataExportTaskWithChan invokes the drds.CreateCustomDataExportTask API asynchronously
func (client *Client) CreateCustomDataExportTaskWithChan(request *CreateCustomDataExportTaskRequest) (<-chan *CreateCustomDataExportTaskResponse, <-chan error) {
	responseChan := make(chan *CreateCustomDataExportTaskResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.CreateCustomDataExportTask(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// CreateCustomDataExportTaskWithCallback invokes the drds.CreateCustomDataExportTask API asynchronously
func (client *Client) CreateCustomDataExportTaskWithCallback(request *CreateCustomDataExportTaskRequest, callback func(response *CreateCustomDataExportTaskResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *CreateCustomDataExportTaskResponse
		var err error
		defer close(result)
		response, err = client.CreateCustomDataExportTask(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// CreateCustomDataExportTaskRequest is the request struct for api CreateCustomDataExportTask
type CreateCustomDataExportTaskRequest struct {
	*requests.RpcRequest
	ExportParam string `position:"Query" name:"ExportParam"`
}

// CreateCustomDataExportTaskResponse is the response struct for api CreateCustomDataExportTask
type CreateCustomDataExportTaskResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Success   bool   `json:"Success" xml:"Success"`
	TaskId    int64  `json:"TaskId" xml:"TaskId"`
}

// CreateCreateCustomDataExportTaskRequest creates a request to invoke CreateCustomDataExportTask API
func CreateCreateCustomDataExportTaskRequest() (request *CreateCustomDataExportTaskRequest) {
	request = &CreateCustomDataExportTaskRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Drds", "2019-01-23", "CreateCustomDataExportTask", "Drds", "openAPI")
	request.Method = requests.POST
	return
}

// CreateCreateCustomDataExportTaskResponse creates a response to parse from CreateCustomDataExportTask response
func CreateCreateCustomDataExportTaskResponse() (response *CreateCustomDataExportTaskResponse) {
	response = &CreateCustomDataExportTaskResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
