package drds

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeCustomDataExportSrcDstTables invokes the drds.DescribeCustomDataExportSrcDstTables API synchronously
func (client *Client) DescribeCustomDataExportSrcDstTables(request *DescribeCustomDataExportSrcDstTablesRequest) (response *DescribeCustomDataExportSrcDstTablesResponse, err error) {
	response = CreateDescribeCustomDataExportSrcDstTablesResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeCustomDataExportSrcDstTablesWithChan invokes the drds.DescribeCustomDataExportSrcDstTables API asynchronously
func (client *Client) DescribeCustomDataExportSrcDstTablesWithChan(request *DescribeCustomDataExportSrcDstTablesRequest) (<-chan *DescribeCustomDataExportSrcDstTablesResponse, <-chan error) {
	responseChan := make(chan *DescribeCustomDataExportSrcDstTablesResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeCustomDataExportSrcDstTables(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeCustomDataExportSrcDstTablesWithCallback invokes the drds.DescribeCustomDataExportSrcDstTables API asynchronously
func (client *Client) DescribeCustomDataExportSrcDstTablesWithCallback(request *DescribeCustomDataExportSrcDstTablesRequest, callback func(response *DescribeCustomDataExportSrcDstTablesResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeCustomDataExportSrcDstTablesResponse
		var err error
		defer close(result)
		response, err = client.DescribeCustomDataExportSrcDstTables(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeCustomDataExportSrcDstTablesRequest is the request struct for api DescribeCustomDataExportSrcDstTables
type DescribeCustomDataExportSrcDstTablesRequest struct {
	*requests.RpcRequest
	ExportParam string `position:"Query" name:"ExportParam"`
}

// DescribeCustomDataExportSrcDstTablesResponse is the response struct for api DescribeCustomDataExportSrcDstTables
type DescribeCustomDataExportSrcDstTablesResponse struct {
	*responses.BaseResponse
	RequestId              string                 `json:"RequestId" xml:"RequestId"`
	Success                bool                   `json:"Success" xml:"Success"`
	DataExportSrcDstTables DataExportSrcDstTables `json:"DataExportSrcDstTables" xml:"DataExportSrcDstTables"`
}

// CreateDescribeCustomDataExportSrcDstTablesRequest creates a request to invoke DescribeCustomDataExportSrcDstTables API
func CreateDescribeCustomDataExportSrcDstTablesRequest() (request *DescribeCustomDataExportSrcDstTablesRequest) {
	request = &DescribeCustomDataExportSrcDstTablesRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Drds", "2019-01-23", "DescribeCustomDataExportSrcDstTables", "Drds", "openAPI")
	request.Method = requests.POST
	return
}

// CreateDescribeCustomDataExportSrcDstTablesResponse creates a response to parse from DescribeCustomDataExportSrcDstTables response
func CreateDescribeCustomDataExportSrcDstTablesResponse() (response *DescribeCustomDataExportSrcDstTablesResponse) {
	response = &DescribeCustomDataExportSrcDstTablesResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
