package drds

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeDDLTask invokes the drds.DescribeDDLTask API synchronously
func (client *Client) DescribeDDLTask(request *DescribeDDLTaskRequest) (response *DescribeDDLTaskResponse, err error) {
	response = CreateDescribeDDLTaskResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeDDLTaskWithChan invokes the drds.DescribeDDLTask API asynchronously
func (client *Client) DescribeDDLTaskWithChan(request *DescribeDDLTaskRequest) (<-chan *DescribeDDLTaskResponse, <-chan error) {
	responseChan := make(chan *DescribeDDLTaskResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeDDLTask(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeDDLTaskWithCallback invokes the drds.DescribeDDLTask API asynchronously
func (client *Client) DescribeDDLTaskWithCallback(request *DescribeDDLTaskRequest, callback func(response *DescribeDDLTaskResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeDDLTaskResponse
		var err error
		defer close(result)
		response, err = client.DescribeDDLTask(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeDDLTaskRequest is the request struct for api DescribeDDLTask
type DescribeDDLTaskRequest struct {
	*requests.RpcRequest
	DrdsInstanceId string `position:"Query" name:"DrdsInstanceId"`
	DbName         string `position:"Query" name:"DbName"`
	TaskId         string `position:"Query" name:"TaskId"`
}

// DescribeDDLTaskResponse is the response struct for api DescribeDDLTask
type DescribeDDLTaskResponse struct {
	*responses.BaseResponse
	Data Data `json:"Data" xml:"Data"`
}

// CreateDescribeDDLTaskRequest creates a request to invoke DescribeDDLTask API
func CreateDescribeDDLTaskRequest() (request *DescribeDDLTaskRequest) {
	request = &DescribeDDLTaskRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Drds", "2015-04-13", "DescribeDDLTask", "Drds", "openAPI")
	request.Method = requests.POST
	return
}

// CreateDescribeDDLTaskResponse creates a response to parse from DescribeDDLTask response
func CreateDescribeDDLTaskResponse() (response *DescribeDDLTaskResponse) {
	response = &DescribeDDLTaskResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
