package drds

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeMyCatDbList invokes the drds.DescribeMyCatDbList API synchronously
func (client *Client) DescribeMyCatDbList(request *DescribeMyCatDbListRequest) (response *DescribeMyCatDbListResponse, err error) {
	response = CreateDescribeMyCatDbListResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeMyCatDbListWithChan invokes the drds.DescribeMyCatDbList API asynchronously
func (client *Client) DescribeMyCatDbListWithChan(request *DescribeMyCatDbListRequest) (<-chan *DescribeMyCatDbListResponse, <-chan error) {
	responseChan := make(chan *DescribeMyCatDbListResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeMyCatDbList(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeMyCatDbListWithCallback invokes the drds.DescribeMyCatDbList API asynchronously
func (client *Client) DescribeMyCatDbListWithCallback(request *DescribeMyCatDbListRequest, callback func(response *DescribeMyCatDbListResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeMyCatDbListResponse
		var err error
		defer close(result)
		response, err = client.DescribeMyCatDbList(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeMyCatDbListRequest is the request struct for api DescribeMyCatDbList
type DescribeMyCatDbListRequest struct {
	*requests.RpcRequest
	SchemaUrl string `position:"Query" name:"SchemaUrl"`
	RuleUrl   string `position:"Query" name:"RuleUrl"`
}

// DescribeMyCatDbListResponse is the response struct for api DescribeMyCatDbList
type DescribeMyCatDbListResponse struct {
	*responses.BaseResponse
	RequestId string   `json:"RequestId" xml:"RequestId"`
	Success   bool     `json:"Success" xml:"Success"`
	DbNames   []string `json:"DbNames" xml:"DbNames"`
}

// CreateDescribeMyCatDbListRequest creates a request to invoke DescribeMyCatDbList API
func CreateDescribeMyCatDbListRequest() (request *DescribeMyCatDbListRequest) {
	request = &DescribeMyCatDbListRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Drds", "2019-01-23", "DescribeMyCatDbList", "Drds", "openAPI")
	request.Method = requests.POST
	return
}

// CreateDescribeMyCatDbListResponse creates a response to parse from DescribeMyCatDbList response
func CreateDescribeMyCatDbListResponse() (response *DescribeMyCatDbListResponse) {
	response = &DescribeMyCatDbListResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
