package drds

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeMyCatReportInfo invokes the drds.DescribeMyCatReportInfo API synchronously
func (client *Client) DescribeMyCatReportInfo(request *DescribeMyCatReportInfoRequest) (response *DescribeMyCatReportInfoResponse, err error) {
	response = CreateDescribeMyCatReportInfoResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeMyCatReportInfoWithChan invokes the drds.DescribeMyCatReportInfo API asynchronously
func (client *Client) DescribeMyCatReportInfoWithChan(request *DescribeMyCatReportInfoRequest) (<-chan *DescribeMyCatReportInfoResponse, <-chan error) {
	responseChan := make(chan *DescribeMyCatReportInfoResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeMyCatReportInfo(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeMyCatReportInfoWithCallback invokes the drds.DescribeMyCatReportInfo API asynchronously
func (client *Client) DescribeMyCatReportInfoWithCallback(request *DescribeMyCatReportInfoRequest, callback func(response *DescribeMyCatReportInfoResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeMyCatReportInfoResponse
		var err error
		defer close(result)
		response, err = client.DescribeMyCatReportInfo(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeMyCatReportInfoRequest is the request struct for api DescribeMyCatReportInfo
type DescribeMyCatReportInfoRequest struct {
	*requests.RpcRequest
	TaskId requests.Integer `position:"Query" name:"TaskId"`
}

// DescribeMyCatReportInfoResponse is the response struct for api DescribeMyCatReportInfo
type DescribeMyCatReportInfoResponse struct {
	*responses.BaseResponse
	RequestId          string             `json:"RequestId" xml:"RequestId"`
	Success            bool               `json:"Success" xml:"Success"`
	EvaluateReportInfo EvaluateReportInfo `json:"EvaluateReportInfo" xml:"EvaluateReportInfo"`
}

// CreateDescribeMyCatReportInfoRequest creates a request to invoke DescribeMyCatReportInfo API
func CreateDescribeMyCatReportInfoRequest() (request *DescribeMyCatReportInfoRequest) {
	request = &DescribeMyCatReportInfoRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Drds", "2019-01-23", "DescribeMyCatReportInfo", "Drds", "openAPI")
	request.Method = requests.POST
	return
}

// CreateDescribeMyCatReportInfoResponse creates a response to parse from DescribeMyCatReportInfo response
func CreateDescribeMyCatReportInfoResponse() (response *DescribeMyCatReportInfoResponse) {
	response = &DescribeMyCatReportInfoResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
