package drds

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeRdsDrdsDB invokes the drds.DescribeRdsDrdsDB API synchronously
func (client *Client) DescribeRdsDrdsDB(request *DescribeRdsDrdsDBRequest) (response *DescribeRdsDrdsDBResponse, err error) {
	response = CreateDescribeRdsDrdsDBResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeRdsDrdsDBWithChan invokes the drds.DescribeRdsDrdsDB API asynchronously
func (client *Client) DescribeRdsDrdsDBWithChan(request *DescribeRdsDrdsDBRequest) (<-chan *DescribeRdsDrdsDBResponse, <-chan error) {
	responseChan := make(chan *DescribeRdsDrdsDBResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeRdsDrdsDB(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeRdsDrdsDBWithCallback invokes the drds.DescribeRdsDrdsDB API asynchronously
func (client *Client) DescribeRdsDrdsDBWithCallback(request *DescribeRdsDrdsDBRequest, callback func(response *DescribeRdsDrdsDBResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeRdsDrdsDBResponse
		var err error
		defer close(result)
		response, err = client.DescribeRdsDrdsDB(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeRdsDrdsDBRequest is the request struct for api DescribeRdsDrdsDB
type DescribeRdsDrdsDBRequest struct {
	*requests.RpcRequest
	RdsInstanceId  *[]string `position:"Query" name:"RdsInstanceId"  type:"Repeated"`
	DrdsInstanceId string    `position:"Query" name:"DrdsInstanceId"`
}

// DescribeRdsDrdsDBResponse is the response struct for api DescribeRdsDrdsDB
type DescribeRdsDrdsDBResponse struct {
	*responses.BaseResponse
	RequestId  string     `json:"RequestId" xml:"RequestId"`
	Success    bool       `json:"Success" xml:"Success"`
	RdsDrdsDbs RdsDrdsDbs `json:"RdsDrdsDbs" xml:"RdsDrdsDbs"`
}

// CreateDescribeRdsDrdsDBRequest creates a request to invoke DescribeRdsDrdsDB API
func CreateDescribeRdsDrdsDBRequest() (request *DescribeRdsDrdsDBRequest) {
	request = &DescribeRdsDrdsDBRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Drds", "2019-01-23", "DescribeRdsDrdsDB", "Drds", "openAPI")
	request.Method = requests.POST
	return
}

// CreateDescribeRdsDrdsDBResponse creates a response to parse from DescribeRdsDrdsDB response
func CreateDescribeRdsDrdsDBResponse() (response *DescribeRdsDrdsDBResponse) {
	response = &DescribeRdsDrdsDBResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
