package drds

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DropTables invokes the drds.DropTables API synchronously
func (client *Client) DropTables(request *DropTablesRequest) (response *DropTablesResponse, err error) {
	response = CreateDropTablesResponse()
	err = client.DoAction(request, response)
	return
}

// DropTablesWithChan invokes the drds.DropTables API asynchronously
func (client *Client) DropTablesWithChan(request *DropTablesRequest) (<-chan *DropTablesResponse, <-chan error) {
	responseChan := make(chan *DropTablesResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DropTables(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DropTablesWithCallback invokes the drds.DropTables API asynchronously
func (client *Client) DropTablesWithCallback(request *DropTablesRequest, callback func(response *DropTablesResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DropTablesResponse
		var err error
		defer close(result)
		response, err = client.DropTables(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DropTablesRequest is the request struct for api DropTables
type DropTablesRequest struct {
	*requests.RpcRequest
	DrdsInstanceId string `position:"Query" name:"DrdsInstanceId"`
	Tables         string `position:"Query" name:"Tables"`
	DbName         string `position:"Query" name:"DbName"`
}

// DropTablesResponse is the response struct for api DropTables
type DropTablesResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	TaskId    string `json:"TaskId" xml:"TaskId"`
}

// CreateDropTablesRequest creates a request to invoke DropTables API
func CreateDropTablesRequest() (request *DropTablesRequest) {
	request = &DropTablesRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Drds", "2015-04-13", "DropTables", "Drds", "openAPI")
	request.Method = requests.POST
	return
}

// CreateDropTablesResponse creates a response to parse from DropTables response
func CreateDropTablesResponse() (response *DropTablesResponse) {
	response = &DropTablesResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
