package dysmsapi

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// CreateShortParam invokes the dysmsapi.CreateShortParam API synchronously
func (client *Client) CreateShortParam(request *CreateShortParamRequest) (response *CreateShortParamResponse, err error) {
	response = CreateCreateShortParamResponse()
	err = client.DoAction(request, response)
	return
}

// CreateShortParamWithChan invokes the dysmsapi.CreateShortParam API asynchronously
func (client *Client) CreateShortParamWithChan(request *CreateShortParamRequest) (<-chan *CreateShortParamResponse, <-chan error) {
	responseChan := make(chan *CreateShortParamResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.CreateShortParam(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// CreateShortParamWithCallback invokes the dysmsapi.CreateShortParam API asynchronously
func (client *Client) CreateShortParamWithCallback(request *CreateShortParamRequest, callback func(response *CreateShortParamResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *CreateShortParamResponse
		var err error
		defer close(result)
		response, err = client.CreateShortParam(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// CreateShortParamRequest is the request struct for api CreateShortParam
type CreateShortParamRequest struct {
	*requests.RpcRequest
	ResourceOwnerId      requests.Integer `position:"Query" name:"ResourceOwnerId"`
	ResourceOwnerAccount string           `position:"Query" name:"ResourceOwnerAccount"`
	PhoneNumbers         string           `position:"Body" name:"PhoneNumbers"`
	ProdCode             string           `position:"Body" name:"ProdCode"`
	OwnerId              requests.Integer `position:"Query" name:"OwnerId"`
}

// CreateShortParamResponse is the response struct for api CreateShortParam
type CreateShortParamResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Code      string `json:"Code" xml:"Code"`
	Message   string `json:"Message" xml:"Message"`
	Data      Data   `json:"Data" xml:"Data"`
}

// CreateCreateShortParamRequest creates a request to invoke CreateShortParam API
func CreateCreateShortParamRequest() (request *CreateShortParamRequest) {
	request = &CreateShortParamRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Dysmsapi", "2017-05-25", "CreateShortParam", "", "")
	request.Method = requests.POST
	return
}

// CreateCreateShortParamResponse creates a response to parse from CreateShortParam response
func CreateCreateShortParamResponse() (response *CreateShortParamResponse) {
	response = &CreateShortParamResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
