package emr

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ReleaseClusterByTemplateTagForInternal invokes the emr.ReleaseClusterByTemplateTagForInternal API synchronously
func (client *Client) ReleaseClusterByTemplateTagForInternal(request *ReleaseClusterByTemplateTagForInternalRequest) (response *ReleaseClusterByTemplateTagForInternalResponse, err error) {
	response = CreateReleaseClusterByTemplateTagForInternalResponse()
	err = client.DoAction(request, response)
	return
}

// ReleaseClusterByTemplateTagForInternalWithChan invokes the emr.ReleaseClusterByTemplateTagForInternal API asynchronously
func (client *Client) ReleaseClusterByTemplateTagForInternalWithChan(request *ReleaseClusterByTemplateTagForInternalRequest) (<-chan *ReleaseClusterByTemplateTagForInternalResponse, <-chan error) {
	responseChan := make(chan *ReleaseClusterByTemplateTagForInternalResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ReleaseClusterByTemplateTagForInternal(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ReleaseClusterByTemplateTagForInternalWithCallback invokes the emr.ReleaseClusterByTemplateTagForInternal API asynchronously
func (client *Client) ReleaseClusterByTemplateTagForInternalWithCallback(request *ReleaseClusterByTemplateTagForInternalRequest, callback func(response *ReleaseClusterByTemplateTagForInternalResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ReleaseClusterByTemplateTagForInternalResponse
		var err error
		defer close(result)
		response, err = client.ReleaseClusterByTemplateTagForInternal(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ReleaseClusterByTemplateTagForInternalRequest is the request struct for api ReleaseClusterByTemplateTagForInternal
type ReleaseClusterByTemplateTagForInternalRequest struct {
	*requests.RpcRequest
	TemplateTagSet  *[]string        `position:"Query" name:"TemplateTagSet"  type:"Repeated"`
	ResourceOwnerId requests.Integer `position:"Query" name:"ResourceOwnerId"`
}

// ReleaseClusterByTemplateTagForInternalResponse is the response struct for api ReleaseClusterByTemplateTagForInternal
type ReleaseClusterByTemplateTagForInternalResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateReleaseClusterByTemplateTagForInternalRequest creates a request to invoke ReleaseClusterByTemplateTagForInternal API
func CreateReleaseClusterByTemplateTagForInternalRequest() (request *ReleaseClusterByTemplateTagForInternalRequest) {
	request = &ReleaseClusterByTemplateTagForInternalRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Emr", "2016-04-08", "ReleaseClusterByTemplateTagForInternal", "emr", "openAPI")
	request.Method = requests.POST
	return
}

// CreateReleaseClusterByTemplateTagForInternalResponse creates a response to parse from ReleaseClusterByTemplateTagForInternal response
func CreateReleaseClusterByTemplateTagForInternalResponse() (response *ReleaseClusterByTemplateTagForInternalResponse) {
	response = &ReleaseClusterByTemplateTagForInternalResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
