package polardb

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeSQLExplorerPolicy invokes the polardb.DescribeSQLExplorerPolicy API synchronously
func (client *Client) DescribeSQLExplorerPolicy(request *DescribeSQLExplorerPolicyRequest) (response *DescribeSQLExplorerPolicyResponse, err error) {
	response = CreateDescribeSQLExplorerPolicyResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeSQLExplorerPolicyWithChan invokes the polardb.DescribeSQLExplorerPolicy API asynchronously
func (client *Client) DescribeSQLExplorerPolicyWithChan(request *DescribeSQLExplorerPolicyRequest) (<-chan *DescribeSQLExplorerPolicyResponse, <-chan error) {
	responseChan := make(chan *DescribeSQLExplorerPolicyResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeSQLExplorerPolicy(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeSQLExplorerPolicyWithCallback invokes the polardb.DescribeSQLExplorerPolicy API asynchronously
func (client *Client) DescribeSQLExplorerPolicyWithCallback(request *DescribeSQLExplorerPolicyRequest, callback func(response *DescribeSQLExplorerPolicyResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeSQLExplorerPolicyResponse
		var err error
		defer close(result)
		response, err = client.DescribeSQLExplorerPolicy(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeSQLExplorerPolicyRequest is the request struct for api DescribeSQLExplorerPolicy
type DescribeSQLExplorerPolicyRequest struct {
	*requests.RpcRequest
	ResourceOwnerId      requests.Integer `position:"Query" name:"ResourceOwnerId"`
	DBInstanceId         string           `position:"Query" name:"DBInstanceId"`
	ResourceOwnerAccount string           `position:"Query" name:"ResourceOwnerAccount"`
	OwnerAccount         string           `position:"Query" name:"OwnerAccount"`
	OwnerId              requests.Integer `position:"Query" name:"OwnerId"`
}

// DescribeSQLExplorerPolicyResponse is the response struct for api DescribeSQLExplorerPolicy
type DescribeSQLExplorerPolicyResponse struct {
	*responses.BaseResponse
	RequestId          string `json:"RequestId" xml:"RequestId"`
	SQLCollectorStatus string `json:"SQLCollectorStatus" xml:"SQLCollectorStatus"`
}

// CreateDescribeSQLExplorerPolicyRequest creates a request to invoke DescribeSQLExplorerPolicy API
func CreateDescribeSQLExplorerPolicyRequest() (request *DescribeSQLExplorerPolicyRequest) {
	request = &DescribeSQLExplorerPolicyRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("polardb", "2017-08-01", "DescribeSQLExplorerPolicy", "polardb", "openAPI")
	request.Method = requests.POST
	return
}

// CreateDescribeSQLExplorerPolicyResponse creates a response to parse from DescribeSQLExplorerPolicy response
func CreateDescribeSQLExplorerPolicyResponse() (response *DescribeSQLExplorerPolicyResponse) {
	response = &DescribeSQLExplorerPolicyResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
