package polardb

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeSQLLogRecords invokes the polardb.DescribeSQLLogRecords API synchronously
func (client *Client) DescribeSQLLogRecords(request *DescribeSQLLogRecordsRequest) (response *DescribeSQLLogRecordsResponse, err error) {
	response = CreateDescribeSQLLogRecordsResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeSQLLogRecordsWithChan invokes the polardb.DescribeSQLLogRecords API asynchronously
func (client *Client) DescribeSQLLogRecordsWithChan(request *DescribeSQLLogRecordsRequest) (<-chan *DescribeSQLLogRecordsResponse, <-chan error) {
	responseChan := make(chan *DescribeSQLLogRecordsResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeSQLLogRecords(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeSQLLogRecordsWithCallback invokes the polardb.DescribeSQLLogRecords API asynchronously
func (client *Client) DescribeSQLLogRecordsWithCallback(request *DescribeSQLLogRecordsRequest, callback func(response *DescribeSQLLogRecordsResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeSQLLogRecordsResponse
		var err error
		defer close(result)
		response, err = client.DescribeSQLLogRecords(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeSQLLogRecordsRequest is the request struct for api DescribeSQLLogRecords
type DescribeSQLLogRecordsRequest struct {
	*requests.RpcRequest
	ResourceOwnerId      requests.Integer `position:"Query" name:"ResourceOwnerId"`
	StartTime            string           `position:"Query" name:"StartTime"`
	JobId                string           `position:"Query" name:"JobId"`
	AccountName          string           `position:"Query" name:"AccountName"`
	SecurityToken        string           `position:"Query" name:"SecurityToken"`
	State                string           `position:"Query" name:"State"`
	MinConsume           requests.Integer `position:"Query" name:"MinConsume"`
	OwnerId              requests.Integer `position:"Query" name:"OwnerId"`
	LogicalOperator      string           `position:"Query" name:"LogicalOperator"`
	DBName               string           `position:"Query" name:"DBName"`
	MinScanRows          requests.Integer `position:"Query" name:"MinScanRows"`
	HostAddress          string           `position:"Query" name:"HostAddress"`
	SortKey              string           `position:"Query" name:"SortKey"`
	PageNumbers          requests.Integer `position:"Query" name:"PageNumbers"`
	PagingID             string           `position:"Query" name:"PagingID"`
	DBInstanceId         string           `position:"Query" name:"DBInstanceId"`
	TableName            string           `position:"Query" name:"TableName"`
	SqlType              string           `position:"Query" name:"SqlType"`
	ResourceOwnerAccount string           `position:"Query" name:"ResourceOwnerAccount"`
	OwnerAccount         string           `position:"Query" name:"OwnerAccount"`
	MaxRecordsPerPage    requests.Integer `position:"Query" name:"MaxRecordsPerPage"`
	QueryKeyword         string           `position:"Query" name:"QueryKeyword"`
	EndTime              string           `position:"Query" name:"EndTime"`
	MaxConsume           requests.Integer `position:"Query" name:"MaxConsume"`
	ThreadID             string           `position:"Query" name:"ThreadID"`
	ChildDBInstanceIDs   string           `position:"Query" name:"ChildDBInstanceIDs"`
	SortMethod           string           `position:"Query" name:"SortMethod"`
	MaxScanRows          requests.Integer `position:"Query" name:"MaxScanRows"`
}

// DescribeSQLLogRecordsResponse is the response struct for api DescribeSQLLogRecords
type DescribeSQLLogRecordsResponse struct {
	*responses.BaseResponse
	MaxRecordsPerPage int                          `json:"MaxRecordsPerPage" xml:"MaxRecordsPerPage"`
	ItemsNumbers      int                          `json:"ItemsNumbers" xml:"ItemsNumbers"`
	RequestId         string                       `json:"RequestId" xml:"RequestId"`
	EndTime           string                       `json:"EndTime" xml:"EndTime"`
	DBInstanceID      string                       `json:"DBInstanceID" xml:"DBInstanceID"`
	StartTime         string                       `json:"StartTime" xml:"StartTime"`
	TotalRecords      int                          `json:"TotalRecords" xml:"TotalRecords"`
	Finish            string                       `json:"Finish" xml:"Finish"`
	PageNumbers       int                          `json:"PageNumbers" xml:"PageNumbers"`
	JobId             string                       `json:"JobId" xml:"JobId"`
	PagingID          string                       `json:"PagingID" xml:"PagingID"`
	DBInstanceName    string                       `json:"DBInstanceName" xml:"DBInstanceName"`
	Items             ItemsInDescribeSQLLogRecords `json:"Items" xml:"Items"`
}

// CreateDescribeSQLLogRecordsRequest creates a request to invoke DescribeSQLLogRecords API
func CreateDescribeSQLLogRecordsRequest() (request *DescribeSQLLogRecordsRequest) {
	request = &DescribeSQLLogRecordsRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("polardb", "2017-08-01", "DescribeSQLLogRecords", "polardb", "openAPI")
	request.Method = requests.POST
	return
}

// CreateDescribeSQLLogRecordsResponse creates a response to parse from DescribeSQLLogRecords response
func CreateDescribeSQLLogRecordsResponse() (response *DescribeSQLLogRecordsResponse) {
	response = &DescribeSQLLogRecordsResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
