package qualitycheck

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// RetrySubmitAsr invokes the qualitycheck.RetrySubmitAsr API synchronously
func (client *Client) RetrySubmitAsr(request *RetrySubmitAsrRequest) (response *RetrySubmitAsrResponse, err error) {
	response = CreateRetrySubmitAsrResponse()
	err = client.DoAction(request, response)
	return
}

// RetrySubmitAsrWithChan invokes the qualitycheck.RetrySubmitAsr API asynchronously
func (client *Client) RetrySubmitAsrWithChan(request *RetrySubmitAsrRequest) (<-chan *RetrySubmitAsrResponse, <-chan error) {
	responseChan := make(chan *RetrySubmitAsrResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.RetrySubmitAsr(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// RetrySubmitAsrWithCallback invokes the qualitycheck.RetrySubmitAsr API asynchronously
func (client *Client) RetrySubmitAsrWithCallback(request *RetrySubmitAsrRequest, callback func(response *RetrySubmitAsrResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *RetrySubmitAsrResponse
		var err error
		defer close(result)
		response, err = client.RetrySubmitAsr(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// RetrySubmitAsrRequest is the request struct for api RetrySubmitAsr
type RetrySubmitAsrRequest struct {
	*requests.RpcRequest
	ResourceOwnerId requests.Integer `position:"Query" name:"ResourceOwnerId"`
	JsonStr         string           `position:"Query" name:"JsonStr"`
}

// RetrySubmitAsrResponse is the response struct for api RetrySubmitAsr
type RetrySubmitAsrResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Success   bool   `json:"Success" xml:"Success"`
	Code      string `json:"Code" xml:"Code"`
	Message   string `json:"Message" xml:"Message"`
	Data      string `json:"Data" xml:"Data"`
}

// CreateRetrySubmitAsrRequest creates a request to invoke RetrySubmitAsr API
func CreateRetrySubmitAsrRequest() (request *RetrySubmitAsrRequest) {
	request = &RetrySubmitAsrRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Qualitycheck", "2019-01-15", "RetrySubmitAsr", "Qualitycheck", "openAPI")
	request.Method = requests.POST
	return
}

// CreateRetrySubmitAsrResponse creates a response to parse from RetrySubmitAsr response
func CreateRetrySubmitAsrResponse() (response *RetrySubmitAsrResponse) {
	response = &RetrySubmitAsrResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
